{ Copyright (c)1988,89 Ross Neilson Wentworth, All Rights Reserved }
{$A+,B-,D+,E+,F-,I+,L+,N+,O-,R-,S-,V-}
Unit PopUp;

Interface

Uses
  Dos,
  Utility,
  Crt;

Const
  RightShift = $0100;   { right shift key }
  LeftShift  = $0200;   { left shift key  }
  Control    = $0400;   { control key     }
  ALT        = $0800;   { ALT key         }

Function  Installed(Var Signature : String;OurID : Byte) : Byte;

Procedure StayResident(OurID : Byte;Vector,HaltPtr : Pointer;HotKeyOne,HotKeyTwo: Word);

Procedure ReleaseEnvironment;   { releases the environment memory }

Implementation

Var
  ProgramVector : Pointer;   { address of popup program           }
  HaltVector    : Pointer;   { address of exit routine            }
  oldDTA        : Pointer;   { interrupted DTA                    }
  OurDTA        : Pointer;   { our DTA                            }
  PrevBreak     : Boolean;   { previous BREAK status              }
  EnvReleased   : Boolean;

Procedure ReleaseEnvironment;

{ Releases the memory of the environment segment. }

Begin
  If Not EnvReleased Then
  Begin
    ReleaseBlock(MemW[PrefixSeg:$002C]); { free the enviornment }
    EnvReleased := True;
  End;
End;

Procedure EntryInit;

Begin
  PrevBreak := GetBreakStatus;      { save the BREAK status flag           }
  SetBreakStatus(False);            { turn of BREAK                        }
  OldDTA := GetDTAVec;              { get the current DTA address          }
  SetDTAVec(OurDTA);                { set it to our own address            }
  SwapVectors;                      { install our interrupt vectors        }
End;

Procedure EntryExit;

Begin
  SwapVectors;                      { restore the interrupt vectors        }
  SetDTAVec(OldDTA);                { restore the DTA address              }
  SetBreakStatus(PrevBreak);        { restore the original BREAKing status }
End;

Procedure ReleaseProgram; Interrupt;

{ Releases the program's memory.  We call this when unhooking the program. }

Begin
  If HaltVector <> Nil Then
  Begin
    EntryInit;
    InLine($FF/$1E/>HaltVector);
    EntryExit;
  End;
  ReleaseBlock(PrefixSeg);
  ReleaseEnvironment;
End;

Procedure CriticalHandler; External; {$L crit.obj}
 { internal routine - don't ever call direct }

Procedure CallPopUp; Interrupt;

{ set some interrupt vectors and run the popup progams }
{ restore the interrupt vectors when done              }

Begin
  EntryInit;
  InLine($FF/$1E/>ProgramVector);   { call the user's procedure            }
  EntryExit;
End;

Function Installed(Var Signature : String;OurID : Byte) : Byte; External;

Procedure InitializePopUp(OurID : Byte;HotKeyOne,HotKeyTwo : Word); External;

  { sets interrupt vectors }
{$L popup.obj}

Procedure StayResident(OurID : Byte;Vector,HaltPtr : Pointer;HotKeyOne,HotKeyTwo : Word);

{ saves some info and Terminated and Stays Resident }

Begin
  OurDTA := GetDTAVec;              { save our DTA address               }
  SetIntVec($23,@CriticalHandler);  { install our critical error handler }
  SwapVectors;                      { restore all the vectors, save ours }
  ProgramVector := Vector;          { save the user program address      }
  HaltVector := HaltPtr;            { Our exit routine                   }
    { install our interrupt vectors      }
  InitializePopUp(OurId,HotKeyOne,HotKeyTwo);
  Keep(0);                          { terminate and stay resident        }
End;

Begin
  CheckBreak := False;              { ignore the control break key }
  EnvReleased := False;             { environment not yet released }
End.
