{ Copyright (c)1989 Ross Neilson Wentworth, All Rights Reserved }
{$A+,B-,D+,E+,F-,I+,L+,N+,O-,R-,S-,V-}
Unit Strings;

Interface

Uses
  Dos;

Type
  NameExtStr = String[12];

Function ChangeChar(Line : String;OldChar,NewChar : Char) : String;

Function Chars(Ch : Char;Count : Byte) : String;

Function DelChar(Ch : Char;Line : String) : String;

Function ExtensionOnly(FileName : PathStr) : ExtStr;

Function ExtractWords(Line : String;Start,Count : Byte) : String;

Function FileNameAndExt(FileName : PathStr) : NameExtStr;

Function FileNameOnly(FileName : PathStr) : NameStr;

Function LastPos(Ch : Char;Line : String) : Byte;

Function Left(Line : String;Count : Byte) : String;

Function LoCase(Ch : Char) : Char;

Function LongDay(DOW : Word) : String;

Function LongMonth(Month : Word) : String;

Function LowerCase(Line : String) : String;

Function NextPos(Ch : Char;Line : String;Last : Byte) : Byte;

Function NoLeadSpace(Line : String) : String;

Function NoLeadTrailSpace(Line : String) : String;

Function NoTrailSpace(Line : String) : String;

Function PadCenter(Line : String;Ch : Char;Count : Byte) : String;

Function PadLeft(Line : String;Ch : Char;Count : Byte) : String;

Function PadRight(Line : String;Ch : Char;Count : Byte) : String;

Function PathOnly(FileName : PathStr) : DirStr;

Function PosWord(Line : String;Number : Byte) : Byte;

Function PrevPos(Ch : Char;Line : String;Last : Byte) : Byte;

Function Reverse(Line : String) : String;

Function Right(Line : String;Count : Byte) : String;

Function ShortDay(DOW : Word) : String;

Function ShortMonth(Month : Word) : String;

Function UpperCase(Line : String) : String;

Function WordCount(Line : String) : Byte;

Implementation

Function ChangeChar(Line : String;OldChar,NewChar : Char) : String; External;

Function Chars(Ch : Char;Count : Byte) : String; External;

Function DelChar(Ch : Char;Line : String) : String; External;

Function LastPos(Ch : Char;Line : String) : Byte; External;

Function Left(Line : String;Count : Byte) : String; External;

Function LoCase(Ch : Char) : Char; External;

Function LongDay(DOW : Word) : String; External;

Function LongMonth(Month : Word) : String; External;

Function LowerCase(Line : String) : String; External;

Function NextPos(Ch : Char;Line : String;Last : Byte) : Byte; External;

Function NoLeadSpace(Line : String) : String; External;

Function NoTrailSpace(Line : String) : String; External;

Function PadLeft(Line : String;Ch : Char;Count : Byte) : String; External;

Function PadRight(Line : String;Ch : Char;Count : Byte) : String; External;

Function PosWord(Line : String;Number : Byte) : Byte; External;

Function PrevPos(Ch : Char;Line : String;Last : Byte) : Byte; External;

Function Reverse(Line : String) : String; External;

Function Right(Line : String;Count : Byte) : String; External;

Function ShortDay(DOW : Word) : String; External;

Function ShortMonth(Month : Word) : String; External;

Function UpperCase(Line : String) : String; External;

Function WordCount(Line : String) : Byte; External;

(**********************************************************************)

Function PadCenter(Line : String;Ch : Char;Count : Byte) : String;

Var
  Amount : Byte;

Begin
  If Length(Line) < Count Then
  Begin
    Amount := Length(Line) + ((Count - Length(Line)) Div 2);
    Line := PadLeft(Line,Ch,Amount);
    Line := PadRight(Line,Ch,Count);
  End;
  PadCenter := Line;
End;

Function ExtractWords(Line : String;Start,Count : Byte) : String;

Var
  sIndex : Integer;
  number : Integer;

Begin
  sIndex := PosWord(Line,Start);
  If sIndex = 0
    Then ExtractWords := ''
  Else Begin
    Number := PosWord(Line,Start+Count);
    If Number = 0 Then Number := Succ(Length(Line));
    Number := Number - sIndex;
    ExtractWords := NoTrailSpace(Copy(Line,sIndex,Number));
  End;
End;

Function PathOnly(FileName : PathStr) : DirStr;

Var
  Dir   : DirStr;
  Name  : NameStr;
  Ext   : ExtStr;

Begin
  FSplit(FileName,Dir,Name,Ext);
  PathOnly := Dir;
End;

Function FileNameAndExt(FileName : PathStr) : NameExtStr;

Var
  Dir   : DirStr;
  Name  : NameStr;
  Ext   : ExtStr;

Begin
  FSplit(FileName,Dir,Name,Ext);
  FileNameAndExt := Name + Ext;
End;

Function FileNameOnly(FileName : PathStr) : NameStr;

Var
  Dir   : DirStr;
  Name  : NameStr;
  Ext   : ExtStr;

Begin
  FSplit(FileName,Dir,Name,Ext);
  FileNameOnly := Name;
End;

Function ExtensionOnly(FileName : PathStr) : ExtStr;

Var
  Dir   : DirStr;
  Name  : NameStr;
  Ext   : ExtStr;

Begin
  FSplit(FileName,Dir,Name,Ext);
  ExtensionOnly := Ext;
End;

Function NoLeadTrailSpace(Line : String) : String;

Begin
  NoLeadTrailSpace := NoLeadSpace(NoTrailSpace(Line));
End;

{$L strings.obj}

End.

